# Copyright (c) 2014  Dave Love, University of Liverpool
# Licence as for the package itself

# fixme: Use beagle somehow?  See below.
#        Build other --enable-... stuff?

%if 0%{?el6}
%global mpich mpich2
%global mpich_load %_mpich2_load
%global mpich_unload %_mpich2_unload
%else
%global mpich mpich
%global mpich_load %_mpich_load
%global mpich_unload %_mpich_unload
%endif

Name:		phyml
Version:	20140606
Release:	3%{?dist}
Summary:	Phylogenetic estimation using Maximum Likelihood

License:	GPLv2+
URL:		https://phyml.googlecode.com/
Source0:	https://github.com/stephaneguindon/phyml-downloads/releases/download/development/phyml-%version.tar.gz
Source1:	phyml.1
BuildRequires:	openmpi-devel %mpich-devel

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%global desc \
PhyML is a software that estimates maximum likelihood phylogenies from\
alignments of nucleotide or amino acid sequences. It provides a wide range of\
options that were designed to facilitate standard phylogenetic analyses. The\
main strengths of PhyML lies in the large number of substitution models coupled\
to various options to search the space of phylogenetic tree topologies, going\
from very fast and efficient methods to slower but generally more accurate\
approaches. It also implements two methods to evaluate branch supports in a\
sound statistical framework (the non-parametric bootstrap and the approximate\
likelihood ratio test).\
\
PhyML was designed to process moderate to large data sets. In theory,\
alignments with up to 4,000 sequences 2,000,000 character-long can be analyzed.\
In  practice however, the amount of memory required to process a data set is\
proportional of the product of the number of sequences by their length. Hence,\
a large number of sequences can only be processed provided that they are short.\
Also, PhyML can handle long sequences provided that they are not numerous. With\
most standard personal computers, the “comfort zone” for PhyML generally lies\
around 3 to 500 sequences less than 2,000 character long.

%description
%desc

%package openmpi
Summary:	Phylogenetic estimation using Maximum Likelihood - openmpi version
Group:		Applications
BuildRequires:	openmpi-devel
Requires:	openmpi

%description openmpi
%desc

This package provides the openmpi version.

%package %mpich
Summary:	Phylogenetic estimation using Maximum Likelihood - %mpich version
Group:		Applications
BuildRequires:	%mpich-devel
Requires:	%mpich

%description %mpich
%desc

This package provides the %mpich version.

%package doc
Summary:	Phylogenetic estimation using Maximum Likelihood - documentation
Group:		Applications
BuildArch:	noarch

%description doc
DOcumentation for %name.

%prep
%setup -q
rm bin/*			# DOS script/binary
iconv -f ISO8859-1 -t UTF-8 ChangeLog >ChangeLog.x
mv ChangeLog.x ChangeLog


%build
%global _configure ../configure
mkdir openmpi serial %mpich
pushd serial
# Can't --enable-beagle, which seems to want v1, not the v2 which is packaged
%configure --disable-mpi
make %{?_smp_mflags}
# This excludes phyml itself
%configure --disable-mpi --enable-phytime
make %{?_smp_mflags}
popd
pushd openmpi
%{_openmpi_load}
%configure --enable-mpi --bindir=$MPI_BIN --program-suffix=$MPI_SUFFIX
make %{?_smp_mflags}
%{_openmpi_unload}
popd
pushd openmpi
%{mpich_load}
%configure --enable-mpi --bindir=$MPI_BIN --program-suffix=$MPI_SUFFIX
make %{?_smp_mflags}
%{mpich_unload}
popd


%install
rm -rf $RPM_BUILD_ROOT
%{_openmpi_load}
install -D openmpi/src/phyml-mpi $RPM_BUILD_ROOT$MPI_BIN/%name$MPI_SUFFIX
%{_openmpi_unload}
%{mpich_load}
install -D openmpi/src/phyml-mpi $RPM_BUILD_ROOT$MPI_BIN/%name$MPI_SUFFIX
%{mpich_unload}
make -C serial install DESTDIR=$RPM_BUILD_ROOT
install serial/src/phyml $RPM_BUILD_ROOT%_bindir
install -m 644 -D %SOURCE1 $RPM_BUILD_ROOT/%_mandir/man1/%name.1

%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc AUTHORS COPYING
%_bindir/*

%files doc
%defattr(-,root,root,-)
%doc AUTHORS COPYING examples doc/phyml-manual.pdf ChangeLog
%_mandir/man1/*

%files openmpi
%defattr(-,root,root,-)
%doc AUTHORS COPYING
%_libdir/openmpi/bin/%{name}_openmpi

%files %mpich
%defattr(-,root,root,-)
%doc AUTHORS COPYING
%_libdir/%mpich/bin/%{name}_%mpich

%changelog
* Mon Jul 14 2014 Dave Love <d.love@liverpool.ac.uk> - 20140606-3
- Actually build serial phytime

* Tue Jul  1 2014 Dave Love <d.love@liverpool.ac.uk> - 20140606-2
- Add mpich version
- Zap DOS stuff

* Wed Jun 18 2014 Dave Love <d.love@liverpool.ac.uk> - 20140606-1
- Update (to development) version
- Make doc and openmpi packages
- Drop patch

* Fri Nov 15 2013 Dave Love <d.love@liverpool.ac.uk> - 20120412-1
- Initial packaging, incuding Debian man page
